import type { Nullable, Reference, ReferenceSymbol } from '@glimmer/interfaces';
export declare const REFERENCE: ReferenceSymbol;
export type { Reference as default };
export type { Reference };
export interface ReferenceEnvironment {
    getProp(obj: unknown, path: string): unknown;
    setProp(obj: unknown, path: string, value: unknown): unknown;
}
export declare function createPrimitiveRef<T extends string | symbol | number | boolean | null | undefined>(value: T): Reference<T>;
export declare const UNDEFINED_REFERENCE: Reference<undefined>;
export declare const NULL_REFERENCE: Reference<null>;
export declare const TRUE_REFERENCE: Reference<true>;
export declare const FALSE_REFERENCE: Reference<false>;
export declare function createConstRef<T>(value: T, debugLabel: false | string): Reference<T>;
export declare function createUnboundRef<T>(value: T, debugLabel: false | string): Reference<T>;
export declare function createComputeRef<T = unknown>(compute: () => T, update?: Nullable<(value: T) => void>, debugLabel?: false | string): Reference<T>;
export declare function createReadOnlyRef(ref: Reference): Reference;
export declare function isInvokableRef(ref: Reference): boolean;
export declare function createInvokableRef(inner: Reference): Reference;
export declare function isConstRef(_ref: Reference): boolean;
export declare function isUpdatableRef(_ref: Reference): boolean;
export declare function valueForRef<T>(_ref: Reference<T>): T;
export declare function updateRef(_ref: Reference, value: unknown): void;
export declare function childRefFor(_parentRef: Reference, path: string): Reference;
export declare function childRefFromParts(root: Reference, parts: string[]): Reference;
export declare let createDebugAliasRef: undefined | ((debugLabel: string, inner: Reference) => Reference);
